<template>
  <q-layout view="lHh Lpr lFf">
    <q-header>
      <q-toolbar class="bg-white">
        <q-toolbar-title class="q-ml-xl">
          <q-img src="~src/assets/logo.png" alt="Logo alpacs" class="cursor-pointer" width="120px" @click="$router.push({ name: 'Home' })" v-if="($router.currentRoute.name !== 'Home')"/>
          <q-img src="~src/assets/logo.png" alt="Logo alpacs" width="120px" v-else/>
        </q-toolbar-title>
        <q-btn
          flat
          dense
          round
          @click="leftDrawerOpen = !leftDrawerOpen"
          aria-label="Menu"
          icon="search"
          color="primary"
          class="q-mx-md"
        />
        <q-drawer
          v-model="leftDrawerOpen"
          behavior="mobile"
          @click="leftDrawerOpen = false"
          content-class="bg-white"
        >
          <q-scroll-area class="fit">
            <q-toolbar class="text-center">
              <q-toolbar-title class="row items-center text-grey-8">
                <q-img src="~src/assets/logo.jpg" alt="Logo alpacs" width="120px"/>
              </q-toolbar-title>
            </q-toolbar>

            <q-list dense>
              <q-expansion-item
                group="somegroup2"
                icon="search"
                label="Buscar"
                header-class="text-primary text-left"
                expand-icon-class="text-primary"
              >
                <q-card>
                  <q-card-section class="text-primary text-center">
                    <q-select
                      :value="id"
                      v-model="model"
                      color="secondary"
                      use-input
                      dense
                      hide-selected
                      fill-input
                      input-debounce="0"
                      input-class="text-primary"
                      :options="options"
                      options-dense
                      @input-value="setModel"
                      hint="Introduce una ID"
                      style=""
                      label-color="primary"
                    >
                      <template v-slot:no-option>
                        <q-item>
                          <q-item-section class="text-grey">
                            No se encontraron resultados
                          </q-item-section>
                        </q-item>
                      </template>
                      <template v-if="id" v-slot:append>
                        <q-icon name="cancel" color="primary" @click.stop="model = null" class="cursor-pointer" />
                      </template>
                    </q-select>
                    <q-input
                      v-model="numberNode"
                      hint="Introduce la cantidad de nodos a mostrar"
                      dense
                      color="secondary"
                      mask="###"
                      input-class="text-primary"
                    >
                    </q-input>
                  </q-card-section>
                  <q-card-section class="text-primary text-center">
                    <q-btn
                      :disable="active"
                      unelevated
                      rounded
                      color="secondary"
                      label="Search"
                      @click="submitFile()"
                      no-caps
                      :loading="loading"
                    />
                  </q-card-section>
                </q-card>
              </q-expansion-item>
            </q-list>
          </q-scroll-area>
        </q-drawer>
      </q-toolbar>
    </q-header>
    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<style lang="scss">
.q-select__dropdown-icon {
color: $primary;
}
.q-field__messages > div {
color: $primary;
}
</style>

<script>
import axios from 'axios'

let stringOptions = []

export default {
  name: 'MainLayout',
  data () {
    return {
      leftDrawerOpen: false,
      group: '',
      loading: false,
      listID: [],
      id: null,
      options: [],
      numberNode: '',
      model: null,
      options2: []
    }
  },
  computed: {
    active () {
      if (this.shape !== '') {
        return false
      }
      return true
    }
  },
  methods: {
    submitFile () {
      return this.$router.push({ name: 'Result', params: { id: this.model.value.split('.')[0], nodes: this.numberNode } })
    },
    filterFn (val, update, abort) {
      update(() => {
        const needle = val.toLocaleLowerCase()
        this.options = stringOptions.filter(v => v.toLocaleLowerCase().indexOf(needle) > -1)
      })
    },
    setModel (val) {
      this.id = val
    }
    /* myRule (val) {
      const found = stringOptions.find(element => element === val)
      if (!found) {
        return 'id no válido'
      }
      console.log(found)
    } */
  },
  mounted () {
    this.$q.loading.show({
      message: '<h6>Cargando</h6>',
      backgroundColor: 'primary',
      spinnerColor: 'secondary'
    })
    axios.get('http://146.83.95.14:8081/files/')
      .then((res) => {
        const arrayStudyID = res.data.map(element => {
          return { label: element.StudyUID, value: element.Filename }
        })
        stringOptions = arrayStudyID
        this.options = stringOptions
        console.log(this.options)
      })
      .catch((err) => {
        console.log(err)
      })
      .finally(() => {
        this.$q.loading.hide()
      })
    // stringOptions = ['hola', 'a', 'todos']
  }
}
</script>
